<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');
	
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

require FORUM_ROOT.'extensions/pan_image_migration/functions.php';

if (file_exists(FORUM_ROOT.'extensions/pan_image_migration/lang/'.$forum_user['language'].'/pan_image_migration.php') )
	require FORUM_ROOT.'extensions/pan_image_migration/lang/'.$forum_user['language'].'/pan_image_migration.php';
else
	require FORUM_ROOT.'extensions/pan_image_migration/lang/English/pan_image_migration.php';

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

$section = isset($_GET['act']) ? $_GET['act'] : '0';

if (file_exists(FORUM_ROOT.'extensions/pan_image_migration/style/'.$forum_user['style'].'/admin.css')) {
	$forum_loader->add_css(FORUM_ROOT.'extensions/pan_image_migration/style/'.$forum_user['style'].'/admin.css');
} else {
	$forum_loader->add_css(FORUM_ROOT.'extensions/pan_image_migration/style/Oxygen/admin.css');
}

if (isset($_POST['update_config']))
{
	$form = array_map('trim', $_POST['form']);
	pan_update_options($form);

	$forum_flash->add_info($lang_pan_image_migration['settings_updated']);
	redirect(forum_link($forum_url['pan_image_migration']), $lang_pan_image_migration['settings_updated']);
}

if ($section == 'local')
{
	$old_path_imgs = FORUM_ROOT.$forum_config['o_pan_image_migration_path'];
	$all_files = PanListImages($old_path_imgs);

	if (isset($_POST['copy_one_image']))
	{
		$year = date('Y', time());
		$tid = $_POST['tid'];
		$pid = $_POST['pid'];
		$old_path = forum_trim($_POST['old_path']);
		$img_name = forum_trim($_POST['img_name']);
		$new_path = 'uploads/images/'.$year.'/'.$tid.'/'.$pid;

		PanImagesCreateCatalog($year, $tid, $pid);

		if(file_exists(FORUM_ROOT.$old_path) && is_dir(FORUM_ROOT.$new_path))
		{
			copy(FORUM_ROOT.$old_path, FORUM_ROOT.$new_path.'/'.$img_name);

			if(file_exists(FORUM_ROOT.$new_path.'/'.$img_name))
			{
				$old_url = $base_url.'/'.$old_path;
				$new_url = $base_url.'/'.$new_path.'/'.$img_name;
				$img_info = pathinfo(FORUM_ROOT.$new_path.'/'.$img_name);
				$img_size = filesize(FORUM_ROOT.$new_path.'/'.$img_name);

				$query = array(
					'SELECT'	=> 'p.id, p.poster, p.poster_id, p.poster_ip, p.message, p.posted',
					'FROM'		=> 'posts AS p',
					'WHERE'		=> 'p.id='.$pid,
				);
				$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
				$fetch_posts = $forum_db->fetch_assoc($result);

				$message = str_replace($old_url, $new_url, $fetch_posts['message']);

				$query = array(
					'UPDATE'	=> 'posts',
					'SET'		=> 'message=\''.$forum_db->escape($message).'\'',
					'WHERE'		=> 'id='.$pid
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);

				$query = array(
					'SELECT'	=> 'file_url',
					'FROM'		=> 'uploaded_files',
					'WHERE'		=> 'file_url=\''.$forum_db->escape($new_path.'/'.$img_name).'\''
				);
				$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
				if($forum_db->num_rows($result) == 0)
				{
					$query = array(
						'INSERT'	=> 'base_name, user_id, user_name, user_ip, file_url, file_loaded, file_type, file_ext, file_size, topic_id, post_id',
						'INTO'		=> 'uploaded_files',
						'VALUES'	=> '\''.$forum_db->escape($img_name).'\', '.$fetch_posts['poster_id'].', \''.$forum_db->escape($fetch_posts['poster']).'\', \''.$forum_db->escape($fetch_posts['poster_ip']).'\', \''.$forum_db->escape($new_path.'/'.$img_name).'\', '.$fetch_posts['posted'].', \''.$forum_db->escape('image').'\',  \''.$forum_db->escape('.'.$img_info['extension']).'\', \''.$forum_db->escape($img_size).'\', '.$tid.', '.$pid
					);
					$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
				}
			}
		}

		$forum_flash->add_info($lang_pan_image_migration['imgs_migrated']);
		redirect(forum_link($forum_url['pan_image_migration_local']), $lang_pan_image_migration['imgs_migrated']);
	}

	if (isset($_POST['copy_one_page']))
	{
		$img_ids = $_POST['img_ids'];
		//Get One Post Id
		foreach($img_ids as $key => $pid)
		{
			$query = array(
				'SELECT'	=> 'p.id, p.poster, p.poster_id, p.poster_ip, p.message, p.posted, p.topic_id',
				'FROM'		=> 'posts AS p',
				'WHERE'		=> 'p.id='.$pid,
			);

			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$fetch_post = $forum_db->fetch_assoc($result);

			//Get One Link of Message
			foreach($all_files as $img_name => $images)
			{
				$image_path = str_replace(FORUM_ROOT, '', $images);

				//If tfis Link Found
				if(stristr($fetch_post['message'], $base_url.'/'.$image_path))
				{
					$year = date('Y', $fetch_post['posted']);
					$month = date('m', $fetch_post['posted']);
					$day = date('d', $fetch_post['posted']);
					$new_path = 'uploads/images/'.$year.'/'.$month.'/'.$day;
					PanImagesCreateCatalog($year, $month, $day);

					if(file_exists(FORUM_ROOT.$image_path) && is_dir(FORUM_ROOT.$new_path))
					{
						copy(FORUM_ROOT.$image_path, FORUM_ROOT.$new_path.'/'.$img_name);

						if(file_exists(FORUM_ROOT.$new_path.'/'.$img_name))
						{
							$old_url = $base_url.'/'.$image_path;
							$new_url = $base_url.'/'.$new_path.'/'.$img_name;
							$img_info = pathinfo(FORUM_ROOT.$new_path.'/'.$img_name);
							$img_size = filesize(FORUM_ROOT.$new_path.'/'.$img_name);
							$message = str_replace($old_url, $new_url, $fetch_post['message']);

							$query = array(
								'UPDATE'	=> 'posts',
								'SET'		=> 'message=\''.$forum_db->escape($message).'\'',
								'WHERE'		=> 'id='.$pid
							);
							$forum_db->query_build($query) or error(__FILE__, __LINE__);
							
							$query = array(
								'SELECT'	=> 'file_url',
								'FROM'		=> 'uploaded_files',
								'WHERE'		=> 'file_url=\''.$forum_db->escape($new_path.'/'.$img_name).'\''
							);
							$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
							if($forum_db->num_rows($result) == 0)
							{
								$query = array(
									'INSERT'	=> 'base_name, user_id, user_name, user_ip, file_url, file_loaded, file_type, file_ext, file_size, topic_id, post_id',
									'INTO'		=> 'uploaded_files',
									'VALUES'	=> '\''.$forum_db->escape($img_name).'\', '.$fetch_post['poster_id'].', \''.$forum_db->escape($fetch_post['poster']).'\', \''.$forum_db->escape($fetch_post['poster_ip']).'\', \''.$forum_db->escape($new_path.'/'.$img_name).'\', '.$fetch_post['posted'].', \''.$forum_db->escape('image').'\',  \''.$forum_db->escape('.'.$img_info['extension']).'\', \''.$forum_db->escape($img_size).'\', '.$fetch_post['topic_id'].', '.$fetch_post['id']
								);
								$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
							}
						}
					}
				}
			}
		}
		$forum_flash->add_info($lang_pan_image_migration['imgs_migrated']);
		redirect(forum_link($forum_url['pan_image_migration_local']), $lang_pan_image_migration['imgs_migrated']);
	}

	if (isset($all_files))
	{
		$query = array(
			'SELECT'	=> 'p.id, p.message',
			'FROM'		=> 'posts AS p',
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

		$num_imgs = 0;
		$arr_ids = array();
		while ($fetch_imgs = $forum_db->fetch_assoc($result))
		{
			foreach($all_files as $img_name => $images)
			{
				$image_path = str_replace(FORUM_ROOT, '', $images);
				if(stristr($fetch_imgs['message'], $base_url.'/'.$image_path))
				{
					$arr_ids[] = $fetch_imgs['id'];
					$num_imgs++;
				}
			}
		}

		if ($num_imgs > 0)
		{
			//Page Navigation
			$forum_page['num_pages'] = ceil($num_imgs / $forum_config['o_pan_image_migration_num_imgs']);
			$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
			$forum_page['start_from'] = $forum_config['o_pan_image_migration_num_imgs'] * ($forum_page['page'] - 1);
			$forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_config['o_pan_image_migration_num_imgs']), ($num_imgs));
			$forum_page['items_info'] = generate_items_info($lang_pan_image_migration['images'], ($forum_page['start_from'] + 1), $num_imgs);
			
			if($forum_page['num_pages'] > 1)
				$forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_pan_image_migration['pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $forum_url['pan_image_migration_local'], '', array('?act=pgs', sef_friendly('Files'))).'</p>';

		}
	}

	$forum_page['crumbs'] = array(
			array($forum_config['o_board_title'], forum_link($forum_url['index'])),
			array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
			array($lang_pan_image_migration['uploader'], forum_link($forum_url['pan_uploader'])),
			array($lang_pan_image_migration['delegation'], forum_link($forum_url['pan_image_migration'])),
			$lang_pan_image_migration['delegation_local']
	);

	$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

	define('FORUM_PAGE_SECTION', 'pan_uploader');
	define('FORUM_PAGE', 'admin-pan-image-migration');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();
?>
	<div class="main-subhead">
		<div class="admin-sub-item">
			<ul>
				<li><a href="<?php echo forum_link($forum_url['pan_image_migration']) ?>"><?php echo $lang_pan_image_migration['delegation_conf'] ?></a></li>
				<li class="active"><a href="<?php echo forum_link($forum_url['pan_image_migration_local']) ?>"><?php echo $lang_pan_image_migration['delegation_local'] ?></a></li>
			</ul>
		</div>
	</div>

	<div class="main-content main-frm">
<?php
//print_r($all_files);
	if ($num_imgs > 0)
	{
?>
		<div class="content-head">
			<h2 class="hn"><span><?php echo $lang_pan_image_migration['list_imgs'] ?><strong><?php echo $num_imgs ?></strong></span></h2>
		</div>
<?php
		$query = array(
			'SELECT'	=> 'p.id AS pid, p.message, t.id AS tid, t.subject',
			'FROM'		=> 'posts AS p',
			'JOINS'		=> array(
				array(
					'INNER JOIN'	=> 'topics AS t',
					'ON'			=> 't.id=p.topic_id'
				)
			),
			'WHERE'		=> 'p.id IN ("'.implode('","',$arr_ids).'")',
			'ORDER BY'	=> 'p.id ASC',
			'LIMIT'		=> $forum_page['start_from'].', '.$forum_config['o_pan_image_migration_num_imgs']
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

		$i = 1;
		$img_ids_page = array();
		while ($fetch_posts = $forum_db->fetch_assoc($result))
		{
			foreach($all_files as $img_name => $images)
			{
				$image_path = str_replace(FORUM_ROOT, '', $images);
				if(stristr($fetch_posts['message'], $base_url.'/'.$image_path))
				{
					$img_ids_page[] = $fetch_posts['pid'];
?>
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_image_migration_local']) ?>">
			
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_image_migration_local'])) ?>" />
			</div>

			<input type="hidden" name="tid" value="<?php echo $fetch_posts['tid'] ?>" />
			<input type="hidden" name="pid" value="<?php echo $fetch_posts['pid'] ?>" />
			<input type="hidden" name="old_path" value="<?php echo $image_path ?>" />
			<input type="hidden" name="img_name" value="<?php echo $img_name ?>" />

			<div class="ct-set report data-set set">
				<div class="ct-box data-box">
					<h3 class="ct-legend hn"><strong></strong>
						<cite class="username">
							<a href="<?php echo forum_link($image_path) ?>" target="_blank">
								<img src="<?php echo forum_link($image_path) ?>"  style="max-width:190px; height: 60px;"/>
							</a>
						</cite> 
						<span></span>
					</h3>
					<h4 class="hn">
						<strong><?php echo $lang_pan_image_migration['subject'] ?><a href="<?php echo forum_link($forum_url['post'], $fetch_posts['pid']) ?>" target="_blank" title="<?php echo $lang_pan_image_migration['go_to_msg'] ?>"><?php echo $fetch_posts['subject'] ?></a></strong>
					</h4>
					<h4 class="hn">
						<input type="submit" name="copy_one_image" value="<?php echo $lang_pan_image_migration['copy_this_img'] ?>" onclick="return confirm('<?php echo $lang_pan_image_migration['copy_this_img_confirm'] ?>')"/>
					</h4>
				</div>
			</div>
		</form>
<?php
					$i++;
				}
			}
		}

?>
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_image_migration_local']) ?>">
			
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_image_migration_local'])) ?>" />
			</div>
<?php
		foreach($img_ids_page as $key => $pids){
?>
			<input type="hidden" name="img_ids[]" value="<?php echo  $pids ?>" />
<?php
		}
?>
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="copy_one_page" value="<?php echo $lang_pan_image_migration['movie_all'] ?>" /></span>
			</div>
		</form>
<?php
	} else {
?>
		<div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
			<p><strong><?php echo $lang_pan_image_migration['img_not_found'] ?></strong></p>
		</div>
<?php
	}

} else {

	$forum_page['crumbs'] = array(
			array($forum_config['o_board_title'], forum_link($forum_url['index'])),
			array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
			array($lang_pan_image_migration['uploader'], forum_link($forum_url['pan_uploader'])),
			array($lang_pan_image_migration['delegation'], forum_link($forum_url['pan_image_migration'])),
			$lang_pan_image_migration['delegation_conf']
	);

	$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

	define('FORUM_PAGE_SECTION', 'pan_uploader');
	define('FORUM_PAGE', 'admin-pan-image-migration');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();
?>
	<div class="main-subhead">
		<div class="admin-sub-item current-item">
			<ul>
				<li class="active"><a href="<?php echo forum_link($forum_url['pan_image_migration']) ?>"><?php echo $lang_pan_image_migration['delegation_conf'] ?></a></li>
				<li><a href="<?php echo forum_link($forum_url['pan_image_migration_local']) ?>"><?php echo $lang_pan_image_migration['delegation_local'] ?></a></li>
			</ul>
		</div>
	</div>

	<div class="main-content main-frm">

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_image_migration']) ?>">
			
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_image_migration'])) ?>" />
			</div>

			<div class="content-head">
				<h2 class="hn"><span><?php echo $lang_pan_image_migration['delegation_settings'] ?></span></h2>
			</div>

			<legend class="group-legend"><strong><?php echo $lang_pan_image_migration['delegation_settings'] ?></strong></legend>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_image_migration['num_imgs'] ?></span><small><?php echo $lang_pan_image_migration['num_imgs_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" id="fld" name="form[pan_image_migration_num_imgs]" size="50" value="<?php echo forum_htmlencode($forum_config['o_pan_image_migration_num_imgs']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_image_migration['path_dir_imgs'] ?></span><small><?php echo $lang_pan_image_migration['path_dir_imgs_i'] ?> Excemple: extensions/hcs_image_uploader/uploads/0</small></label><br />
					<span class="fld-input"><input type="text" id="fld" name="form[pan_image_migration_path]" size="50" value="<?php echo forum_htmlencode($forum_config['o_pan_image_migration_path']) ?>" /></span>
				</div>
			</div>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="update_config" value="<?php echo $lang_pan_image_migration['save_config'] ?>" /></span>
			</div>
		</form>

<?php
}
?>
		<div id="info-censored-intro" class="ct-box">
			<p>More info on <a href="http://panbb.ru/forum/" target="_blank" title="Open new tab">PanBB.ru</a></p>
		</div>

	</div>
<?php
$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';